> For the complete documentation index, see [llms.txt](https://getheminames.gitbook.io/getheminames/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://getheminames.gitbook.io/getheminames/developers/resolving.md).

# Resolving

### Forward Resolve (from Name to Address) <a href="#forward-resolve-from-name-to-address" id="forward-resolve-from-name-to-address"></a>

## Onchain

Assuming you have minted yourname.hemi with correct data (or correct setAddr), you need to call resolve on the universal resolver passing the dns encoded form of the name and the function you want to call (in this case, addr(bytes node)). Code can be found HERE

#### With Viem <a href="#with-viem" id="with-viem"></a>

{% embed url="<https://viem.sh/docs/ens/actions/getEnsAddress.html>" %}

```javascript
const ensAddress = await publicClient.getEnsAddress({
  name: normalize('test.hemi'),
})
```

### Reverse Resolve (from Address to Name) <a href="#reverse-resolve-from-address-to-name" id="reverse-resolve-from-address-to-name"></a>

#### &#x20;Onchain <a href="#onchain-1" id="onchain-1"></a>

Assuming you have minted test.hemi with correct data (or correct setAddr), you need to call reverse on the universal resolver passing the dns encoded form of the reverse address. Check ENS documentation if you need more

#### With Viem <a href="#with-viem-1" id="with-viem-1"></a>

{% embed url="<https://viem.sh/docs/ens/actions/getEnsName>" %}

```javascript
const ensName = await publicClient.getEnsName({
  address: '<your address>',
})
return ensName // =>yourname.hemi
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://getheminames.gitbook.io/getheminames/developers/resolving.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
